// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"gochassis/ent/chatroom"
	"gochassis/ent/post"
	"strings"
	"time"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
)

// ChatRoom is the model entity for the ChatRoom schema.
type ChatRoom struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// RoomName holds the value of the "room_name" field.
	RoomName string `json:"room_name,omitempty"`
	// CreatedAt holds the value of the "created_at" field.
	CreatedAt time.Time `json:"created_at,omitempty"`
	// UpdatedAt holds the value of the "updated_at" field.
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// DeletedAt holds the value of the "deleted_at" field.
	DeletedAt time.Time `json:"deleted_at,omitempty"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the ChatRoomQuery when eager-loading is set.
	Edges           ChatRoomEdges `json:"edges"`
	post_chat_rooms *int
	selectValues    sql.SelectValues
}

// ChatRoomEdges holds the relations/edges for other nodes in the graph.
type ChatRoomEdges struct {
	// Post holds the value of the post edge.
	Post *Post `json:"post,omitempty"`
	// Chats holds the value of the chats edge.
	Chats []*Chat `json:"chats,omitempty"`
	// Profiles holds the value of the profiles edge.
	Profiles []*Profile `json:"profiles,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [3]bool
}

// PostOrErr returns the Post value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ChatRoomEdges) PostOrErr() (*Post, error) {
	if e.loadedTypes[0] {
		if e.Post == nil {
			// Edge was loaded but was not found.
			return nil, &NotFoundError{label: post.Label}
		}
		return e.Post, nil
	}
	return nil, &NotLoadedError{edge: "post"}
}

// ChatsOrErr returns the Chats value or an error if the edge
// was not loaded in eager-loading.
func (e ChatRoomEdges) ChatsOrErr() ([]*Chat, error) {
	if e.loadedTypes[1] {
		return e.Chats, nil
	}
	return nil, &NotLoadedError{edge: "chats"}
}

// ProfilesOrErr returns the Profiles value or an error if the edge
// was not loaded in eager-loading.
func (e ChatRoomEdges) ProfilesOrErr() ([]*Profile, error) {
	if e.loadedTypes[2] {
		return e.Profiles, nil
	}
	return nil, &NotLoadedError{edge: "profiles"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*ChatRoom) scanValues(columns []string) ([]any, error) {
	values := make([]any, len(columns))
	for i := range columns {
		switch columns[i] {
		case chatroom.FieldID:
			values[i] = new(sql.NullInt64)
		case chatroom.FieldRoomName:
			values[i] = new(sql.NullString)
		case chatroom.FieldCreatedAt, chatroom.FieldUpdatedAt, chatroom.FieldDeletedAt:
			values[i] = new(sql.NullTime)
		case chatroom.ForeignKeys[0]: // post_chat_rooms
			values[i] = new(sql.NullInt64)
		default:
			values[i] = new(sql.UnknownType)
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the ChatRoom fields.
func (cr *ChatRoom) assignValues(columns []string, values []any) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case chatroom.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			cr.ID = int(value.Int64)
		case chatroom.FieldRoomName:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field room_name", values[i])
			} else if value.Valid {
				cr.RoomName = value.String
			}
		case chatroom.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[i])
			} else if value.Valid {
				cr.CreatedAt = value.Time
			}
		case chatroom.FieldUpdatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[i])
			} else if value.Valid {
				cr.UpdatedAt = value.Time
			}
		case chatroom.FieldDeletedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field deleted_at", values[i])
			} else if value.Valid {
				cr.DeletedAt = value.Time
			}
		case chatroom.ForeignKeys[0]:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for edge-field post_chat_rooms", value)
			} else if value.Valid {
				cr.post_chat_rooms = new(int)
				*cr.post_chat_rooms = int(value.Int64)
			}
		default:
			cr.selectValues.Set(columns[i], values[i])
		}
	}
	return nil
}

// Value returns the ent.Value that was dynamically selected and assigned to the ChatRoom.
// This includes values selected through modifiers, order, etc.
func (cr *ChatRoom) Value(name string) (ent.Value, error) {
	return cr.selectValues.Get(name)
}

// QueryPost queries the "post" edge of the ChatRoom entity.
func (cr *ChatRoom) QueryPost() *PostQuery {
	return NewChatRoomClient(cr.config).QueryPost(cr)
}

// QueryChats queries the "chats" edge of the ChatRoom entity.
func (cr *ChatRoom) QueryChats() *ChatQuery {
	return NewChatRoomClient(cr.config).QueryChats(cr)
}

// QueryProfiles queries the "profiles" edge of the ChatRoom entity.
func (cr *ChatRoom) QueryProfiles() *ProfileQuery {
	return NewChatRoomClient(cr.config).QueryProfiles(cr)
}

// Update returns a builder for updating this ChatRoom.
// Note that you need to call ChatRoom.Unwrap() before calling this method if this ChatRoom
// was returned from a transaction, and the transaction was committed or rolled back.
func (cr *ChatRoom) Update() *ChatRoomUpdateOne {
	return NewChatRoomClient(cr.config).UpdateOne(cr)
}

// Unwrap unwraps the ChatRoom entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (cr *ChatRoom) Unwrap() *ChatRoom {
	_tx, ok := cr.config.driver.(*txDriver)
	if !ok {
		panic("ent: ChatRoom is not a transactional entity")
	}
	cr.config.driver = _tx.drv
	return cr
}

// String implements the fmt.Stringer.
func (cr *ChatRoom) String() string {
	var builder strings.Builder
	builder.WriteString("ChatRoom(")
	builder.WriteString(fmt.Sprintf("id=%v, ", cr.ID))
	builder.WriteString("room_name=")
	builder.WriteString(cr.RoomName)
	builder.WriteString(", ")
	builder.WriteString("created_at=")
	builder.WriteString(cr.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(cr.UpdatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("deleted_at=")
	builder.WriteString(cr.DeletedAt.Format(time.ANSIC))
	builder.WriteByte(')')
	return builder.String()
}

// ChatRooms is a parsable slice of ChatRoom.
type ChatRooms []*ChatRoom
